<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import VueSlickCarousel from 'vue-slick-carousel';
import { init, refresh } from 'aos';
import {
  SlpContainer,
  SlpRow,
  SlpColumn as SlpCol,
  Faq as FAQ,
  Modal as SlpModal,
  NextStep,
} from '~/components/common/index.vue';
import {
  NextSteps,
  Addons,
  FeatureComparison,
  FeatureList,
} from '~/components/pricing/index.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    SlpContainer,
    SlpRow,
    SlpCol,
    FAQ,
    NextSteps,
    VueSlickCarousel,
    SlpModal,
    FeatureList,
    Addons,
    NextStep,
    FeatureComparison,
  },
  layout: 'minimized-navigation',
  async asyncData({ $content }) {
    const data = await $content('pricing/index').fetch();
    return { data };
  },
  data() {
    return {
      width: 1025,
      activeCarouselIndex: 1,
      isModalOpen: false,
      modalPlan: {},
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).data, this.$route.path);
  },
  computed: {
    isMobile(): boolean {
      return this.width <= 1024;
    },
  },
  beforeMount() {
    init({
      once: true,
    });
  },
  mounted() {
    this.onResize();
    window.addEventListener('resize', this.onResize);
    refresh();
  },
  destroyed() {
    window.removeEventListener('resize', this.onResize);
  },
  methods: {
    onResize() {
      this.width = window.innerWidth;
    },
    carouselGoTo(index: number): void {
      const carouselRef = this.$refs.carousel as any;
      this.activeCarouselIndex = index;
      if (carouselRef.goTo) {
        carouselRef.goTo(index);
      }
    },
    handleCarouselChange(index: number): void {
      this.activeCarouselIndex = index;
    },
    openModal(plan: Object) {
      this.isModalOpen = true;
      this.modalPlan = plan;
    },
    closeModal() {
      this.isModalOpen = false;
    },
    getTiersanimation(planIndex: number) {
      switch (planIndex) {
        case 0:
          return 'fade-right';
        case 1:
          return 'fade-down';
        case 2:
          return 'fade-left';
        default:
          return '';
      }
    },
  },
});
</script>

<template>
  <div class="pricing-container">
    <SlpContainer class="carousel-container">
      <h1
        tag="h1"
        variant="heading1"
        class="pricing-header"
        data-aos="fade-right"
        data-aos-duration="800"
        v-html="data.heading"
      />
      <div v-if="isMobile" class="carousel-controls">
        <button
          class="free"
          :class="{ active: activeCarouselIndex === 0 }"
          @click="carouselGoTo(0)"
        >
          <SlpTypography variant="body1-bold"> Free </SlpTypography>
        </button>
        <button
          class="premium"
          :class="{ active: activeCarouselIndex === 1 }"
          @click="carouselGoTo(1)"
        >
          <SlpTypography variant="body1-bold"> Premium </SlpTypography>
        </button>
        <button
          class="ultimate"
          :class="{ active: activeCarouselIndex === 2 }"
          @click="carouselGoTo(2)"
        >
          <SlpTypography variant="body1-bold"> Ultimate </SlpTypography>
        </button>
      </div>
      <section class="tiers-section">
        <component
          :is="isMobile ? 'VueSlickCarousel' : 'slp-row'"
          ref="carousel"
          center-mode
          :center-padding="`${width / 30}%`"
          :infinite="false"
          :dots="true"
          class="tiers"
          :initial-slide="1"
          @afterChange="handleCarouselChange"
        >
          <SlpCol
            v-for="(plan, planIndex) in data.plans"
            :key="plan.heading"
            class="column"
            :data-aos="getTiersanimation(planIndex)"
            data-aos-duration="800"
            :class="`${plan.id}-container`"
          >
            <div :class="['tier ' + 'plan-' + plan.id]">
              <div class="content">
                <SlpTypography
                  v-if="!isMobile"
                  tag="h2"
                  variant="heading3"
                  class="title"
                  >{{ plan.title }}</SlpTypography
                >
                <SlpTypography
                  tag="p"
                  variant="heading5"
                  class="description bold"
                >
                  {{ plan.description }}</SlpTypography
                >
                <div class="price-container">
                  <span class="dollar-sign"> $ </span>
                  <SlpTypography variant="heading1" class="price">{{
                    plan.monthly_price
                  }}</SlpTypography>
                </div>

                <SlpTypography tag="p" variant="body2" class="price-monthly"
                  >per user/month</SlpTypography
                >
                <SlpTypography
                  v-if="plan.monthly_price === 0"
                  tag="p"
                  variant="body2"
                  class="price-annually"
                >
                  No credit card required<sup class="asterisk">*</sup>
                </SlpTypography>
                <SlpTypography
                  v-else
                  tag="p"
                  variant="body2"
                  class="price-annually"
                >
                  Billed annually at ${{ plan.monthly_price * 12 }} USD
                </SlpTypography>
                <div
                  :data-ga-name="plan.data_ga_name"
                  :data-ga-location="plan.data_ga_location"
                  @click="openModal(plan)"
                >
                  <SlpButton
                    :variant="plan.title === 'Free' ? 'tertiary' : 'primary'"
                  >
                    {{ plan.button_copy }}
                    <img
                      v-if="plan.title === 'Free'"
                      class="chevron"
                      src="/nuxt-images/icons/slp-chevron-lg.svg"
                      alt=""
                    />
                  </SlpButton>
                </div>
              </div>
            </div>
            <FeatureList
              :data="plan.features"
              :tooltip-position="isMobile ? 'bottom' : 'right'"
            />
          </SlpCol>
        </component>
      </section>
      <p class="subtitle">{{ data.subtitle }}</p>
    </SlpContainer>
    <SlpContainer>
      <FeatureComparison
        :plans="data.plans"
        :data="data.feature_comparison"
        @planSelect="(event) => openModal(event)"
      />
    </SlpContainer>
    <SlpContainer>
      <Addons :data="data.addons" />
    </SlpContainer>

    <section>
      <NextSteps :data="data.next_steps" />
    </section>
    <SlpContainer variant="light-purple-100">
      <FAQ :data="data.faq" data-aos="fade-right" data-aos-duration="800" />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
    <slp-modal v-if="isModalOpen" @close="closeModal">
      <div class="buy-modal">
        <div class="modal-header">
          <SlpTypography tag="h3" variant="heading3-bold"
            >Select your preferred hosting setup</SlpTypography
          >
        </div>
        <div class="types-container">
          <div class="plan-type saas">
            <SlpTypography tag="h3" variant="heading4">
              GitLab SaaS</SlpTypography
            >
            <SlpTypography tag="p" variant="body2"> (We Host)</SlpTypography>
            <SlpTypography tag="p" variant="body1" class="experience-notice">
              No technical setup required.</SlpTypography
            >
            <SlpTypography tag="p" variant="body2" class="description">
              If you don't want to worry about downloading and installing GitLab
              yourself.
            </SlpTypography>
            <SlpButton
              class="purchase-button"
              variant="primary"
              :href="modalPlan.links.hosted.url"
              :data-ga-location="`${modalPlan.id}-modal`"
              :data-ga-name="modalPlan.links.hosted.cta_text"
              >{{ modalPlan.links.hosted.cta_text }}</SlpButton
            >
          </div>
          <div class="plan-type self-managed">
            <SlpTypography tag="h3" variant="heading4">
              GitLab Self-Managed</SlpTypography
            >
            <SlpTypography tag="p" variant="body2"> (You Host)</SlpTypography>
            <SlpTypography tag="p" variant="body1" class="experience-notice">
              Requires Linux Experience.</SlpTypography
            >
            <SlpTypography tag="p" variant="body2" class="description">
              Download and install GitLab on your own infrastructure or in our
              public cloud environment.
            </SlpTypography>
            <SlpButton
              class="purchase-button"
              :data-ga-name="modalPlan.links.self_managed.cta_text"
              :data-ga-location="`${modalPlan.id}-modal`"
              :href="modalPlan.links.self_managed.url"
              >{{ modalPlan.links.self_managed.cta_text }}</SlpButton
            >
          </div>
        </div>
      </div>
    </slp-modal>
  </div>
</template>

<style lang="scss">
// Allowing overflow in carousel component to prevent tooltips from being cut
.slick-list {
  overflow: visible !important;
}
</style>

<style lang="scss" scoped>
.pricing-container {
  // Added for the AOS animations, the components are initially displaced with an opacity of 0, which causes them to move outside the container
  // creating a horizontal scrollbar in mobile
  @media (max-width: $breakpoint-lg) {
    overflow: hidden;
  }
}

.pricing-header {
  font-size: 48px;
  line-height: 64px;
  padding-left: $spacing-16;
  font-weight: 600;
  @media (min-width: $breakpoint-lg) {
    padding-left: $spacing-64;
    margin-top: $spacing-96;
    font-size: 68px;
    line-height: 88px;
    text-align: left;
  }
}

.bold {
  font-weight: 600;
}

.buy-modal {
  padding: $spacing-32 40px;
  display: flex;
  flex-direction: column;
  .modal-header {
    margin-bottom: $spacing-24;
    text-align: center;
  }
  .types-container {
    display: flex;
    @media (max-width: $breakpoint-lg) {
      flex-direction: column;
      align-items: center;
    }

    .plan-type {
      display: flex;
      flex-direction: column;
      align-items: center;
      padding: $spacing-24 0;
      min-width: 275px;
      max-width: 300px;
      text-align: center;
      &.saas {
        padding-right: 1rem;
        border-right: 1px solid #d7d7d7;
        @media (max-width: $breakpoint-lg) {
          border-bottom: 1px solid #d7d7d7;
          border-top: 1px solid #d7d7d7;
          border-right: none;
          padding-bottom: 24px;
          margin-bottom: 24px;
          padding-right: 0;
        }
      }

      &.self-managed {
        padding-left: 1rem;
        @media (max-width: $breakpoint-lg) {
          padding-left: 0;
        }
      }
      .experience-notice {
        font-weight: 600;
        margin-top: 1rem;
      }
      .description {
        margin-bottom: 1rem;
      }
      .purchase-button {
        width: 100%;
        margin-top: auto;
        justify-content: center;
      }
      .slp-button-secondary {
        background-color: #9b51e0;
      }
    }
  }
}

div.slp-col-md.column {
  height: 100%;
  padding: 0.8rem;
  max-width: 350px;
  position: relative;
  &.free-container {
    z-index: 2;
  }
  &.silver-premium-container {
    z-index: 1;
  }
  &.gold-ultimate-container {
    z-index: 0;
  }
}

div.carousel-container {
  margin-bottom: $spacing-96;
  @media (max-width: $breakpoint-lg) {
    padding-right: 0;
    padding-left: 0;
  }
}

.carousel-controls {
  display: flex;
  width: 100%;
  justify-content: space-around;
  height: 42px;
  margin-top: $spacing-24;
  button {
    border: none;
    width: 100%;
    border-bottom: 1px solid transparent;
    opacity: 0.2;
    color: $color-primary-200;
    &.active {
      border-bottom: 1px solid #171321;
      opacity: 1;
    }
  }
}

.tiers {
  margin: $spacing-24 auto;
  justify-content: center;
  .tier {
    text-align: left;
    border-radius: $border-radius-4;
    border-style: solid;
    padding: $spacing-24 $spacing-24 $spacing-64 $spacing-24;
    height: 100%;
    border: 1px solid transparent;
    margin-bottom: $spacing-32;
    min-height: 422px;
    max-height: 422px;
    @media (min-width: $breakpoint-lg) {
      padding: $spacing-48 $spacing-32 $spacing-64 $spacing-32;
    }

    &.plan-free {
      background-color: $color-surface-100;
      .asterisk {
        vertical-align: top;
      }
      .chevron {
        margin-left: 18px;
      }
      button {
        padding: 0;
        &:hover {
          background: transparent;
          text-decoration: underline;
        }
      }
    }

    &.plan-silver-premium {
      background-color: $color-surface-900;
    }

    &.plan-gold-ultimate {
      border-radius: 4px 4px 100px 4px;
      background: url('/nuxt-images/backgrounds/ultimate_tier_gradient.png');
      border: 1px solid $color-surface-900;
      background-size: cover;
      background-repeat: no-repeat;
      background-position: center center;
    }
  }

  .content {
    .title {
      font-weight: 600;
      @media (max-width: $breakpoint-lg) {
        font-size: 30px;
      }
    }
    .description {
      margin-bottom: $spacing-16;
    }

    .price-container {
      display: flex;
      .dollar-sign {
        position: relative;
        top: 15px;
      }

      .price {
        font-weight: 600;
      }
    }
  }
}

.price-annually {
  margin-bottom: $spacing-24;
}

.card {
  a {
    font-weight: $font-weight-bold;
    color: $color-text-link-100;
    font-size: $text-body-2;
  }

  h3 {
    margin-bottom: $spacing-16;
  }
}
</style>
